#pragma once

#include <memory>

#include "core/editor.h"
#include "core/timeline.h"

#include "game/classicnote.h"
#include "classicmode/classicactions.h"

class ClassicGraphicsManager;

class ClassicEditor : public Editor
{
public:
    explicit ClassicEditor(const std::shared_ptr<Timeline<ClassicNote>>& timeline,
                           const std::shared_ptr<ClassicGraphicsManager>& graphics_manager);

    virtual void input(PlayerInput&& inputdata) override;
    virtual void update(UpdateData&& updatedata) override;
    virtual void display() const override;
    virtual void recalculate(const microsec& timestamp) override;

    void selectNoteType(Type type) noexcept;

private:
    inline microsec adjustOffset(microsec offset) const noexcept;

    Context _context;

    const std::shared_ptr<Timeline<ClassicNote>> _timeline;
    const std::shared_ptr<ClassicGraphicsManager> _graphics_manager;

    Type _selected_type;
    microsec _current_time;
    microsec _scroll_step;
};
