#pragma once

#include <memory>
#include <array>

#include "mockelement.h"
#include "game/classicnote.h"
#include "initializers/mockarrownoteinitializer.h"

class MockClassicNote : public ClassicNote
{
public:
    explicit MockClassicNote(MockArrowNoteInitializer&& init);
    virtual ~MockClassicNote() override = default;

    virtual void putToGame() override;
    virtual void update(const microsec &music_offset) override;
    virtual void input(PlayerInput&& inputdata) override;

    virtual void display(const ClassicGraphicsManager * const manager) const override;
    virtual void setGraphics(ClassicGraphicsManager * const manager, TimeRange&& range) override;

private:
    std::vector<MockElement> _elements;

    State _state;
    const Context *_context;
};
