#pragma once

#include "classicmode/classicactions.h"

#include "core/inputtype.h"
#include "tools/mathutils.h"

#include <memory>
#include <vector>
#include <array>

class ClassicSprite;
class ClassicAnimationScenario;

struct ArrowElement
{
    std::shared_ptr<ClassicSprite> sprite;
    std::array<std::shared_ptr<ClassicAnimationScenario>, 5> animations;
    sf::Keyboard::Key pressed_as = sf::Keyboard::Unknown;

    Coordinates coordinates;
    std::vector<Coordinates> falling_curve_interpolation;
    std::array<sf::Keyboard::Key, 2> keys;
    Type type = Type::NONE;
    bool pressed = false;

    // Each note may consist of several buttons.
    // For example, ↑ → or ↓ → ←
    // Note Element represents this idea.
};
