#pragma once

#include "arrowelement.h"
#include "classicnote.h"
#include "initializers/arrownoteinitializer.h"

class ClassicArrowNote : public ClassicNote
{
public:
    explicit ClassicArrowNote(ArrowNoteInitializer&& init);
    virtual ~ClassicArrowNote() = default;

    virtual void putToGame() override;
    virtual void update(const microsec &music_offset) override;
    virtual void input(PlayerInput&& inputdata) override;

    virtual void display(const ClassicGraphicsManager * const manager) const override;
    virtual void setGraphics(ClassicGraphicsManager * const manager, TimeRange&& range) override;

    bool allElementsPressed() const;
    bool isPressedAs(sf::Keyboard::Key key) const;
    inline bool isHold() const;

private:
    std::vector<ArrowElement> _elements;
    bool _is_hold;
};

using ArrowElements = std::vector<ArrowElement>;
