#pragma once

#include "game/classicnote.h"
#include "graphics/classicgraphicsmanager.h"
#include "core/timeline.h"

class ClassicSprite;

class ClassicSceneGraphicsManager : public ClassicGraphicsManager
{
public:
    explicit ClassicSceneGraphicsManager(const std::shared_ptr<Timeline<ClassicNote>>& timeline,
                                         const std::shared_ptr<ClassicSpriteFactory>& factory,
                                         const microsec& visibility_offset);

    virtual void display() const override;
    virtual void update(const microsec& offset) override;

    virtual void display(const std::vector<ArrowElement>& elements) const override;
    virtual void setGraphics(std::vector<ArrowElement>& elements, TimeRange&& range) override;

protected:
    using Iterator = Timeline<ClassicNote>::Iterator;

    Iterator _first;
    Iterator _last;

    const std::shared_ptr<Timeline<ClassicNote>> _timeline;

    inline bool nothingToDraw() const noexcept;
    inline bool isVisiblyClose(const Iterator& iterator, const microsec& music_offset) const noexcept;
    //inline sf::VertexArray makeLine(const Coordinates& c1, const Coordinates& c2) const;

    void fetchFirstNote(const microsec& offset);
    void fetchLastNote(const microsec& offset);
    void updateVisibleNotes(const microsec& offset);
};
