#pragma once

#include "state.h"
#include "tools/music.h"
#include <SFML/Graphics/RenderWindow.hpp>

class Group;
class Game;

class GameState : public GUIState
{
public:

    struct Callbacks
    {
        std::function<void(void)> onLeaveGame;
    };


    explicit GameState(const std::shared_ptr<Game>& game, Callbacks&& callbacks);

    virtual void input(const sf::Event& event) override;
    virtual void update(const sf::Time& dt) override;
    virtual void draw(sf::RenderTarget& target, sf::RenderStates states) const override;

    virtual void enter(sf::Vector2u&& render_size) override;
    virtual void leave() override;

private:
    Music _music;
    std::shared_ptr<Game> _game;

    std::function<void(void)> _onEnterGameCallback;
    std::function<void(void)> _onLeaveGameCallback;
};

