#pragma once

#include "state.h"
#include "tools/resourceholder.h"
#include <SFML/Graphics/RenderWindow.hpp>

class Group;

class MainMenu : public GUIState
{
public:

    struct Callbacks
    {
        std::function<void(void)> onAppendGameState;
        std::function<void(void)> onAppendEditorState;
    };

    explicit MainMenu(Callbacks&& callbacks, const FontHolder &font_holder);
    virtual void input(const sf::Event& event) override;
    virtual void update(const sf::Time& dt) override;
    virtual void draw(sf::RenderTarget& target, sf::RenderStates states) const override;

    virtual void enter(sf::Vector2u&& render_size) override;
    virtual void leave() override;

private:
    const std::shared_ptr<sf::Font> _font;
    const Callbacks _callbacks;

    std::shared_ptr<Group> _buttons;
};

