#pragma once

#include "button.h"

class PushButton : public Button
{
public:
    explicit PushButton(const std::string& text, const std::shared_ptr<sf::Font>& font, unsigned int font_size = 12);
    virtual void input(const sf::Event& event) override final;

    void setCallback(std::function<void(void)> callback);
    void setFillColors(sf::Color&& idle_color, sf::Color&& pressed_color);

private:
    sf::Color _color_idle;
    sf::Color _color_pressed;

    bool _pressed;
    std::function<void(void)> _on_click_callback;
};

